/*
 * Copyright (c) 2016 NumberFour AG.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   NumberFour AG - Initial API and implementation
 */
(function(global) {
    "use strict";

    var cache = {};
    function req(id) {
        var mod = cache[id];
        return mod ? mod.exports : null;
    }
    req.cache = cache;
    req.resolve = function(id) { return id; };

    if (typeof $makeClass === "undefined") {
        global.n4 = {
            runtimeOptions: global.n4 && global.n4.runtimeOptions || {},
            runtimeInfo: {
                deviceId: undefined,
                isTouch: true,
                platformId: "react-native",
                platformVariant: undefined
            }
        };

        require("./rt/node-url-polyfill.js");

        var Loader = require("./rt/node-cjs-loader-polyfill.js").Loader,
            sys = new Loader(req, null);
        global.System = sys;
        require("n4js-es5/rt.js");
    }

    module.exports = {
        /**
         * Bundle CJS System loader, integrated in react-native.
         */
        System: sys
    };

}(typeof global === "object" ? global : self));
